<template>
  <div
    class="input-group"
    :class="{'input-group--error': companyDataErrors.spendAbility !== ''}"
  >
    <label class="input-label">
      {{label}}
    </label>
    <div class="input input--double">
      <input
        class="input input--to-format"
        @blur="handleBlur"
        v-model="fieldMinModel"
        placeholder="Min"
        type="number"
        :min="0"
      />
      <input
        class="input input--to-format"
        @blur="handleBlur"
        v-model="fieldMaxModel"
        placeholder="Max"
        type="number"
        :min="0"
      />
    </div>
    <p
      class="input input--formatted"
      :class="{'input--placeholder': (companyData.spendAbility.min === '' && companyData.spendAbility.max === '')}"
    >
      {{ (companyData.spendAbility.min !== '' || companyData.spendAbility.max !== '')
        ? formatSpendAbility(companyData.spendAbility)
        : placeholder
      }}
    </p>
    <ErrorMessage fieldName="spendAbility" />
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import ErrorMessage from './ErrorMessage.vue';

export default {
  name: "DoubleInput",
  components: {
    ErrorMessage,
  },
  props: {
    label: String,
    placeholder: String,
  },
  methods: {
    ...mapActions(['updateCompanyField', 'validateField']),
    handleBlur() {
      this.validateField('spendAbility');
    },
    formatSpendAbility(spendAbility){
      const filterNan = value => {
        const numberValue = Number.parseFloat(value);
        return isNaN(numberValue) ? '--' : numberValue.toFixed(2);
      }
      return `$${filterNan(spendAbility.min)} - $${filterNan(spendAbility.max)} `;
    }
  },
  computed: {
    ...mapGetters(['companyData', 'companyDataErrors']),
    fieldMinModel: {
      get () {
        return this.companyData.spendAbility.min;
      },
      set (fieldValue) {
        this.updateCompanyField({
          fieldName: 'spendAbility',
          fieldValue: {
            min: parseFloat(fieldValue),
            max: parseFloat(this.companyData.spendAbility.max),
          }
        });
      }
    },
    fieldMaxModel: {
      get () {
        return this.companyData.spendAbility.max;
      },
      set (fieldValue) {
        this.updateCompanyField({
          fieldName: 'spendAbility',
          fieldValue: {
            min: parseFloat(this.companyData.spendAbility.min),
            max: parseFloat(fieldValue),
          }
        });
      }
    },
  },
}
</script>

<style lang="scss" scoped>
  @import 'Styles/components/input.scss';
</style>

